import { RuleContext, RuleListener } from "@typescript-eslint/experimental-utils/dist/ts-eslint";
import { Type, Symbol, IndexKind, TypeChecker, Signature } from "typescript";
export declare type TypePairArray = ReadonlyArray<{
    readonly destinationType: Type;
    readonly sourceType: Type;
}>;
export declare type SignaturePairArray = ReadonlyArray<{
    readonly destinationSignature: Signature;
    readonly sourceSignature: Signature;
}>;
export declare type MessageId = "errorStringCallExpression" | "errorStringAssignmentExpression" | "errorStringVariableDeclaration" | "errorStringArrowFunctionExpression" | "errorStringTSAsExpression" | "errorStringTSTypeAssertion";
export declare type Context = Readonly<RuleContext<MessageId, readonly []>>;
export declare type UnsafeIndexAssignmentFunc = (indexKind: IndexKind, destinationType: Type, sourceType: Type, checker: TypeChecker) => boolean;
export declare type UnsafePropertyAssignmentFunc = (destinationProperty: Symbol, sourceProperty: Symbol | undefined, destinationType: Type, sourceType: Type, checker: TypeChecker) => boolean;
export declare const createNoUnsafeAssignmentRule: (unsafePropertyAssignmentFunc: UnsafePropertyAssignmentFunc, unsafeIndexAssignmentFunc: UnsafeIndexAssignmentFunc) => (context: Context) => RuleListener;
